﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.7
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Public SQL As SQL
	Public Utility As UtilityClass
	Private ItemListView As CustomListView
	Private Label1 As B4XView
	Private Label2 As B4XView
	Private Label3 As B4XView
	Private Label4 As B4XView
	Private SearchBox As EditText
End Sub


'You can add more parameters here.
Public Sub Initialize As Object
	Utility.Initialize()
End Sub


'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("ItemSelect")		'load the layout to Root
	
	
	'build the top right menu
	B4XPages.AddMenuItem(Me, "Import DB")
	B4XPages.SetTitle(Me, "Movies")
	
End Sub


Private Sub B4XPage_Appear
	
	ItemListView.Clear()
	Main.gItemSearch = ""
	
	'Root.RemoveAllViews
	'Root.LoadLayout("ItemSelect")
	
	ListItems
End Sub


Private Sub ListItems()
	
	Dim Counter As Int = 0
	Dim RS As ResultSet
	Dim SQLQuery As String = ""
	
	
	If Main.gItemSearch = "" Then
		SQLQuery = "select * from movies order by Film"
	Else
		SQLQuery = "select * from movies where Film like '%" & Main.gItemSearch  & "%' order by Film"
	End If
	
	
	Log("Item SQL: " & SQLQuery)
	RS = Utility.ExecSQL(SQLQuery)
	
	
	Do While RS.NextRow
		ItemListView.Add(CreateListItem(RS.GetString("id"), RS.GetString("Film"), RS.GetString("Genre"), RS.GetString("Year"), ItemListView.AsView.Width, 60dip, Counter), RS.GetString("id"))
		'ItemListView.Add(CreateListItem_BAK(RS.GetString("id"), RS.GetString("Film"), RS.GetString("Genre"), RS.GetString("Year"), ItemListView.AsView.Width, 60dip, Counter), RS.GetString("id"))
		Counter = Counter + 1
	Loop
	
	RS.Close
End Sub


Sub CreateListItem(IdentityNo As String, Film As String, Genre As String, Year As String, Width As Int, Height As Int, Counter As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	
	Dim MyView As HorizontalScrollView
	MyView.Initialize(Width, "myview")
	
	MyView.Panel.LoadLayout("ItemSelectItems")
	MyView.Panel.Width = 300%x
	
	Label1.Text = IdentityNo
	Label1.TextColor = Colors.Black
	
	Label2.Text = Film
	Label2.TextColor = Colors.Black
	
	Label3.Text = Genre
	Label4.Text = Year
	
	
	p.AddView(MyView, 0, 0, Width, Height)

	If Film = "Enchanted" Then
		p.Color = Colors.Red
	Else
		If Counter Mod 2 = 0 Then
			p.Color = Colors.White
		Else
			p.Color = Colors.LightGray
		End If
	End If
	
	
	Return p
End Sub



'----------------------------- This works, but no horizontal scroll ---------------------------------------------------
Sub CreateListItem_BAK(IdentityNo As String, Film As String, Genre As String, Year As String, Width As Int, Height As Int, Counter As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	p.LoadLayout("ItemSelectItems")
	
	Label1.Text = IdentityNo
	Label1.TextColor = Colors.Black
	
	Label2.Text = Film
	Label2.TextColor = Colors.Black
	
	Label3.Text = Genre
	Label4.Text = Year
	

	If Film = "Enchanted" Then
		p.Color = Colors.Red
	Else
		If Counter Mod 2 = 0 Then
			p.Color = Colors.White
		Else
			p.Color = Colors.LightGray
		End If
	End If
	
	
	Return p
End Sub


Sub ItemListView_ItemClick(Index As Int, Value As Object)
	ItemListView.AsView.BringToFront
	
	Main.gSelectedItemID = Value
	Log("Selected item's IdentityNo: " & Main.gSelectedItemID)
	
	B4XPages.ShowPage("Page Test")
End Sub


Private Sub SearchBox_EnterPressed
	PerformItemSearch
End Sub


Private Sub cmdSearch_Click
	PerformItemSearch
End Sub


Private Sub cmdReset_Click
	
	Log("Search has been reset")
	
	Main.gItemSearch = ""
	
	Root.RemoveAllViews
	Root.LoadLayout("ItemSelect")
	
	ListItems
End Sub


Sub PerformItemSearch
	
	Dim SearchString As String = SearchBox.Text.Trim()
	
	Log("Item search: " & SearchString)
	
	Main.gItemSearch = SearchString
	
	Root.RemoveAllViews
	Root.LoadLayout("ItemSelect")
	
	ListItems
	
End Sub


Sub B4XPage_MenuClick (Tag As String)	
	
	If Tag = "Import DB" Then
		B4XPages.ShowPage("DB Tools")
	End If
	
End Sub