﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.7
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Public db As SQL
	Public Utility As UtilityClass	
	Private dbTable As B4XTable
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Utility.Initialize()
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1	
	Root.LoadLayout("Table")		'load the layout to Root
	
	B4XPages.AddMenuItem(Me, "Import DB")
	
	Dim Data As List
	Data.Initialize
	Dim rs As ResultSet
	
	rs = Utility.ExecSQL("select id, Film, Genre, Studio, Year from movies order by Film")
	
	Do While rs.NextRow
		Dim row(5) As Object
		row(0) = rs.GetString("id")
		row(1) = rs.GetString("Film")
		row(2) = rs.GetString("Genre")
		
		'Some of the values are Null. We need to convert them to empty strings:
		'If row(2) = Null Then row(2) = ""
		
		row(3) = rs.GetString("Studio")
		row(4) = rs.GetString("Year")
		Data.Add(row)
	Loop
	
	rs.Close
	
	
	'configure and populate the B4XTable
	'dbTable.MaximumRowsPerPage=13
	
	
	dbTable.AddColumn("id", dbTable.COLUMN_TYPE_NUMBERS)
	dbTable.AddColumn("Film", dbTable.COLUMN_TYPE_TEXT)
	dbTable.AddColumn("Genre", dbTable.COLUMN_TYPE_TEXT)
	dbTable.AddColumn("Studio", dbTable.COLUMN_TYPE_TEXT)
	dbTable.AddColumn("Year", dbTable.COLUMN_TYPE_NUMBERS)
	
	'YearColumn = dbTable.GetColumn("Year")
	'CreateCustomFormat(YearColumn)
	
	dbTable.SetData(Data)
	
	dbTable.VisibleColumns.RemoveAt(0)	'hide the first column (the record's ID)
	dbTable.Refresh

End Sub


Private Sub B4XPage_Appear

End Sub




Private Sub CreateCustomFormat (c As B4XTableColumn)
	Dim formatter As B4XFormatter
	formatter.Initialize
	c.Formatter = formatter
	
	Dim Positive As B4XFormatData = c.Formatter.NewFormatData
	Positive.TextColor = dbTable.TextColor
	Positive.FormatFont = xui.CreateDefaultFont(16)
	'c.Formatter.AddFormatData(Positive, 0, c.Formatter.MAX_VALUE, True) 'Inclusive (zero included)
	c.Formatter.AddFormatData(Positive, 2010, c.Formatter.MAX_VALUE, True) 'Inclusive (zero included)
	
	Dim Negative As B4XFormatData = c.Formatter.CopyFormatData(Positive)
	Negative.TextColor = xui.Color_Red
	Negative.FormatFont = xui.CreateDefaultBoldFont(16)
	Negative.Prefix = "("
	Negative.Postfix = ")"
	'c.Formatter.AddFormatData(Negative, c.Formatter.MIN_VALUE, 0, False)
	c.Formatter.AddFormatData(Negative, 1990, 2010, False)
End Sub


Sub DBTable_CellClicked (ColumnId As String, RowId As Long)
	Dim RowData As Map = dbTable.GetRow(RowId)
	Dim id As String = RowData.Get("id")
	
	
	'Dim cell As String = RowData.Get(ColumnId)	'gets the cell's value
	'Log(RowData)
	
	
	id = id.Replace(".0", "")
	B4XPages.SetTitle(Me, id)
	
	
	Main.gSelectedItemID = id
	Log("Selected item's IdentityNo: " & Main.gSelectedItemID)
	
	B4XPages.ShowPage("Page Test")
End Sub


Sub B4XPage_MenuClick (Tag As String)
	
	If Tag = "Import DB" Then
		B4XPages.ShowPage("DB Tools")
	End If
	
End Sub